fibs :: [Integer]
fibs = 0 : 1 : zipWith (+) fibs (tail fibs)

primes :: [Integer]
primes = sieve [2..]
  where
    sieve (x:xs) =
      x : sieve (filter (\y -> y `mod` x /= 0) xs)

replaceAllByMax :: [Integer] -> [Integer]
replaceAllByMax xs = ys
  where
    (m, ys) = maxAndReplaceAll m xs
    maxAndReplaceAll c =
      foldr (\x (m, ys) -> (max x m, c : ys)) (0, [])
